﻿"use strict";

window.WingtipToys = window.WingtipToys || {};
WingtipToys.Rest = WingtipToys.Rest || {};

WingtipToys.Rest.Security = function () {

    var getCurrentUser = function () {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/currentUser",
                type: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }
        );

        return deferred.promise()
    },

    getSiteGroups = function () {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/siteGroups",
                type: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }
        );

        return deferred.promise()
    },

    addSiteGroup = function (title, description) {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/siteGroups",
                type: "POST",
                contentType: "application/json;odata=verbose",
                data: JSON.stringify(
                    {
                        '__metadata': {
                            'type': 'SP.Group'
                        },
                        'Title': title,
                        'Description': description
                    }),
                headers: {
                    "accept": "application/json;odata=verbose",
                    "X-RequestDigest": $("#__REQUESTDIGEST").val()
                }
            }
        );

        return deferred.promise()
    },

    checkPermissions = function (mask) {
        //NOT WORKING

        var permSet = new SP.BasePermissions();
        permSet.set(mask);

        var deferred = $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl +
                "/_api/web/doesUserHavePermissions",
            type: "POST",
            processData: false,
            data: permSet,
            contentType: "application/json;odata=verbose",
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val()
            }
        });

        return deferred.promise()
    };

    return {
        get_currentUser: getCurrentUser,
        get_siteGroups: getSiteGroups,
        add_siteGroup: addSiteGroup,
        check_Permissions: checkPermissions
    };

}();