﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.ViewModel = WingtipToys.ViewModel || {};
WingtipToys.Rest = WingtipToys.Rest || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.ViewModel.Principal = function (title) {

    //private members
    var t = title,
        set_title = function (v) { t = v; },
        get_title = function () { return t; };

    //public interface
    return {
        set_title: set_title,
        get_title: get_title
    };
}

WingtipToys.ViewModel.Rest = function () {

    //private members
    var principals = ko.observableArray(),
        getPrincipals = function () { return principals; },

        load = function () {
            WingtipToys.Rest.Security.get_siteGroups().then(
                function (data) {
                    var results = data.d.results;

                    principals.removeAll();

                    for (var i = 0; i < results.length; i++) {
                        principals.push(new WingtipToys.ViewModel.Principal(results[i].Title));
                    }
                },
                function (err) {
                    items.removeAll();
                    alert(JSON.stringify(err));
                }
             );
        };


    //public interface
    return {
        load: load,
        get_principals: getPrincipals
    };

}();

WingtipToys.ViewModel.Jsom = function () {

    //private members
    var principals = ko.observableArray(),
        getPrincipals = function () { return principals; },

        load = function () {

            //Load Items
            WingtipToys.Jsom.Security.get_siteGroups().then(
                function (groups) {
                    principals.removeAll();

                    var enumerator = groups.getEnumerator();

                    while (enumerator.moveNext()) {
                        var group = enumerator.get_current();
                        principals.push(new WingtipToys.ViewModel.Principal(group.get_title()));
                    }

                },
                function (sender, args) {
                    principals.removeAll();
                    alert(args.get_message());
                }
             );

        };


    //public interface
    return {
        load: load,
        get_principals: getPrincipals
    };

}();
