﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Text;
using Microsoft.SharePoint.Client;

namespace AnnoucementAppWeb
{
    public class AnnouncementsReceiver : IRemoteEventService
    {
        public SPRemoteEventResult ProcessEvent(RemoteEventProperties properties)
        {
            SPRemoteEventResult result = new SPRemoteEventResult();

            switch (properties.EventType)
            {
                case RemoteEventType.ItemAdding:
                    result.ChangedItemProperties = new Dictionary<String, object>();
                    result.ChangedItemProperties.Add("Body", properties.ItemEventProperties.AfterProperties["Body"] += "\n ** For internal use only ** \n");
                    break;

                case RemoteEventType.ItemDeleting:
                    result.ErrorMessage = "Items cannot be deleted from this list";
                    result.Status = SPRemoteEventServiceStatus.CancelWithError;
                    break;
            }

            return result;
        }

        public void ProcessOneWayEvent(RemoteEventProperties properties)
        {
            if (properties.EventType == RemoteEventType.ItemAdded)
            {
                using (Microsoft.SharePoint.Client.ClientContext ctx = new Microsoft.SharePoint.Client.ClientContext(properties.ItemEventProperties.WebUrl))
                {
                    Microsoft.SharePoint.Client.List list = ctx.Web.Lists.GetByTitle(properties.ItemEventProperties.ListTitle);                  
                    ctx.Load(list);
                    Microsoft.SharePoint.Client.ListItem item = list.GetItemById(properties.ItemEventProperties.ListItemId);
                    ctx.Load(item);
                    ctx.ExecuteQuery();
                    item["Body"] += "\n Announcement Tracking ID: " + Guid.NewGuid().ToString() + " \n";
                    item.Update();
                    ctx.ExecuteQuery();
                }
            }

        }
    }
}
