﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.ViewModel = WingtipToys.ViewModel || {};
WingtipToys.Rest = WingtipToys.Rest || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.ViewModel.Document = function (Id, fileLeafRef, fileRef, fileDirRef) {

    //private members
    var id = Id,
        name = fileLeafRef,
        url = fileRef,
        path = fileDirRef,
        set_id = function (v) { id = v; },
        get_id = function () { return id; },
        set_name = function (v) { name = v; },
        get_name = function () { return name; },
        set_url = function (v) { url = v; },
        get_url = function () { return url; },
        set_path = function (v) { path = v; },
        get_path = function () { return path; };

    //public interface
    return {
        set_id: set_id,
        get_id: get_id,
        set_name: set_name,
        get_name: get_name,
        set_url: set_url,
        get_url: get_url,
        set_path: set_path,
        get_path: get_path
    };
}

WingtipToys.ViewModel.Rest = function () {

    //private members
    var items = ko.observableArray(),
        getItems = function () { return items; },

        load = function (listTitle) {
            WingtipToys.Rest.LibItems.readAll(listTitle).then(
                function (data) {
                    var results = data.d.results;

                    items.removeAll();

                    for (var i = 0; i < results.length; i++) {
                        if (results[i].FileSystemObjectType === SP.FileSystemObjectType.file) {
                            items.push(new WingtipToys.ViewModel.Document(
                                results[i].ID,
                                results[i].FileLeafRef,
                                results[i].FileRef,
                                results[i].FileDirRef));
                        }
                    }
                },
                function (err) {
                    items.removeAll();
                    alert(JSON.stringify(err));
                }
             );
        };


    //public interface
    return {
        load: load,
        get_items: getItems
    };

}();

WingtipToys.ViewModel.Jsom = function () {

    //private members
    var items = ko.observableArray(),
        getItems = function () { return items; },

        load = function (listTitle) {

            //Load Items
            WingtipToys.Jsom.LibItems.readAll(listTitle).then(
                function (listItems) {
                    items.removeAll();

                    var enumerator = listItems.getEnumerator();

                    while (enumerator.moveNext()) {
                        var listItem = enumerator.get_current();
                        if (listItem.get_fileSystemObjectType() === SP.FileSystemObjectType.file) {
                            items.push(new WingtipToys.ViewModel.Document(
                                listItem.get_item("ID"),
                                listItem.get_item("FileLeafRef"),
                                listItem.get_item("FileRef"),
                                listItem.get_item("FileDirRef")));
                        }
                    }

                },
                function (sender, args) {
                    items.removeAll();
                    alert(args.get_message());
                }
             );

        };


    //public interface
    return {
        load: load,
        get_items: getItems
    };

}();
