﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using Microsoft.Office.Server.Search;
using Microsoft.Office.Server.Search.Query;
using Microsoft.Office.Server.Search.Administration;
using Microsoft.Office.Server.Search.Administration.Query;

namespace ListResultSources
{
    class Program
    {
        static void Main(string[] args)
        {
            using (SPSite siteCollection = new SPSite("http://intranet.wingtip.com"))
            {
                SPServiceContext ctx = SPServiceContext.GetContext(siteCollection);
                SearchServiceApplicationProxy proxy = ctx.GetDefaultProxy(typeof(SearchServiceApplicationProxy)) as SearchServiceApplicationProxy;
                SearchServiceApplicationInfo info = proxy.GetSearchServiceApplicationInfo();
                SearchServiceApplication ssa = SearchService.Service.SearchServiceApplications.Where(i => i.GetSearchServiceApplicationInfo().SearchServiceApplicationId == info.SearchServiceApplicationId).FirstOrDefault();
                SearchObjectFilter filter = new SearchObjectFilter(SearchObjectLevel.Ssa);
                List<SourceRecord> sources = ssa.GetResultSourceList(filter, false);
                foreach (SourceRecord source in sources)
                {
                    Console.WriteLine(source.Name + ": " + source.Id);
                }
            }

            Console.Read();
        }
    }
}
