﻿"use strict";

var Wingtip = window.Wingtip || {};

Wingtip.Product = function (id, name, catName, stock, reorder) {

    var productId = id,
        categoryName = catName,
        productName = name,
        unitsInStock = stock,
        reorderLevel = reorder,

        get_productId = function () { return productId; },
        set_productId = function (v) { productId = v; },
        get_categoryName = function () { return categoryName; },
        set_categoryName = function (v) { categoryName = v; },
        get_productName = function () { return productName; },
        set_productName = function (v) { productName = v; },
        get_unitsInStock = function () { return unitsInStock; },
        set_unitsInStock = function (v) { unitsInStock = v; },
        get_reorderLevel = function () { return reorderLevel; },
        set_reorderLevel = function (v) { reorderLevel = v; };

    return {
        get_productId: get_productId,
        set_productId: set_productId,
        get_productName: get_productName,
        set_productName: set_productName,
        get_categoryName: get_categoryName,
        set_categoryName: set_categoryName,
        get_unitsInStock: get_unitsInStock,
        set_unitsInStock: set_unitsInStock,
        get_reorderLevel: get_reorderLevel,
        set_reorderLevel: set_reorderLevel,
    }

};

Wingtip.ProductViewModel = function () {

    var products = ko.observableArray(),
    get_products = function () { return products; },

        load = function () {

            var bcs = new Wingtip.BCS();
            bcs.init("NorthwindModel",
                     "Alphabetical_list_of_product",
                     "Northwind OData Source",
                     "ReadAllAlphabetical_list_of_product");

            bcs.getLobSystemInstances().then(

                //success
                function () {
                    bcs.executeFinder(this.collection).then(

                         //success
                         function () {

                             products.removeAll();

                             for (var i = 0; i < this.collection.get_count() ; i++) {
                                 var entityInstance = this.collection.get_item(i);
                                 var fields = entityInstance.get_fieldValues();
                                 products.push(new Wingtip.Product(
                                     fields.ProductID,
                                     fields.ProductName,
                                     fields.CategoryName,
                                     fields.UnitsInStock,
                                     fields.ReorderLevel));
                             }
                         },

                         //failure
                         function (args) {
                             alert("Error: " + args.get_message());
                         }

                         );
                },

                //failure
                function (args) {
                    alert("Error: " + args.get_message());
                }
            );
        };

    return {
        load: load,
        get_products: get_products
    }

}();